#ifndef __ITSWINDOW_HPP
#define __ITSWINDOW_HPP

#define TARGET_BUILD_DEBUG

#include <SophiaFramework.hpp>


//
// ItsWindow class (place container and scroll bar control)
//

SFMTYPEDEFRESPONDER(ItsWindow)
class ItsWindow : public SFZWindow
{
    SFMSEALRESPONDER(ItsWindow)
    SFMRESPONDERINSTANTIATEFOUR(ItsWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
public:

    // since 4-characters type of small alphabets and symbols is reserved
    // define ('I', 'W', 'N', 'D') of capital alphabets for ItsWindow type
    enum CodeEnum {
        CODE_TYPE = four_char_code('I', 'W', 'N', 'D')
    };
    SFMTYPEDEFTYPE(CodeEnum)

public:
    static ItsWindowSmp NewInstance(SFCErrorPtr exception = null);

    // make container and control on ItsWindow
    SFCError Make(Void);

protected:
    explicit ItsWindow(Void) static_throws;
    virtual ~ItsWindow(Void);

private:

    // declare key handler
    XANDLER_DECLARE_BOOLEVENT(OnKey)
};

#endif // __ITSWINDOW_HPP
