#ifndef __TABWINDOW_HPP
#define __TABWINDOW_HPP

#define TARGET_BUILD_DEBUG

#include <SophiaFramework.hpp>
#include "UserColor.hpp"

//
// TabWindow calss (tab control is palced)
//

SFMTYPEDEFRESPONDER(TabWindow)
class TabWindow : public SFZWindow {
    SFMSEALRESPONDER(TabWindow)
    SFMRESPONDERINSTANTIATEFOUR(TabWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
public:

    // since 4-characters type of small alphabets and symbols is reserved 
    // define ('T', 'A', 'B', 'W') of capital alphabets for TabWindow type
    enum CodeEnum {
        CODE_TYPE = four_char_code('T', 'A', 'B', 'W')
    };
    SFMTYPEDEFTYPE(CodeEnum)

private:

    // declare tab control
    SFZTabControlSmp _tab;

public:
    static TabWindowSmp NewInstance(SFCErrorPtr exception = null);

    // make tab control and tab page
    SFCError Make();

protected:
    explicit TabWindow(Void) static_throws;
    virtual ~TabWindow(Void);
private:

    // key handler 
    XANDLER_DECLARE_BOOLEVENT(OnKey)

    // tab color scheme handler
    XANDLER_DECLARE_VOIDUSERCOLOR(OnTabColor)
};

#endif // __TABWINDOW_HPP
