#ifndef __USERCOLOR_HPP
#define __USERCOLOR_HPP

// custom color structure
SFMTYPEDEFSTRUCT(UserColor)
struct UserColor {
    SFMTYPEDEFSTRUCT(AtomRec)
    struct AtomRec {

        // macro to declare implicit type conversion from UserColor::AtomRec to UserColor
        SFMUTILITYATOMDECLARE(UserColor)

        SFXRGBColor::AtomRec light;
        SFXRGBColor::AtomRec base;
        SFXRGBColor::AtomRec dark;
        SFXRGBColor::AtomRec titleFore;
        SFXRGBColor::AtomRec titleBack;
        SFXRGBColor::AtomRec itemFore;
        SFXRGBColor::AtomRec itemBack;
        SFXRGBColor::AtomRec selFore;
        SFXRGBColor::AtomRec selBack;
    };
    SFXRGBColor light;
    SFXRGBColor base;
    SFXRGBColor dark;
    SFXRGBColor titleFore;
    SFXRGBColor titleBack;
    SFXRGBColor itemFore;
    SFXRGBColor itemBack;
    SFXRGBColor selFore;
    SFXRGBColor selBack;
};

// guarantee that sizes of two classes are same
SFMCONCEPTGLOBALTWO(concept_size_eq_type, UserColor, UserColor::AtomRec)

// macro to implement implicit type conversion from UserColor::AtomRec to UserColor
SFMUTILITYATOMIMPLEMENT(UserColor, AtomRec)

#define     XANDLER_DECLARE_VOIDUSERCOLOR(FUNCTION) \
static Bool XANDLER_FUNCTION(FUNCTION)(SFYResponderPtr invoker, SFXEventConstRef event, VoidPtr reference); \
Void FUNCTION(SFYResponderPtr invoker, UInt16 reason, UserColorPtr color);

#define     XANDLER_IMPLEMENT_VOIDUSERCOLOR(TYPE, FUNCTION, INVOKER, REASON, COLOR) \
Bool XANDLER_FUNCTION(TYPE::FUNCTION)(SFYResponderPtr invoker, SFXEventConstRef event, VoidPtr reference) \
{ \
    static_cast<TYPE*>(reference)->FUNCTION(invoker, event.GetP16(), reinterpret_cast<UserColorPtr>(event.GetP32())); \
    return true; \
} \
\
Void TYPE::FUNCTION(SFYResponderPtr INVOKER, UInt16 REASON, UserColorPtr COLOR)

#endif//__USERCOLOR_HPP
